#' calculate quality scores for chromatographic peaks that are part of a batch
#'
#' This function calculates a set of quality scores for chromatographic peaks 
#' using quantifier and qualifier traces. It requires a pre-defined reference sample.
#' This funcion is caled by consensus_peak_update and the GUI
#'
#' @param x1 quantifier chromatogram
#' @param x2 qualifier chromatogram
#' @param x3 13C qualifier chromatogram
#' @param peakstart index of peak start
#' @param peaktop index of peak top
#' @param peakend index of peak end
#' @param nowusetrace 3 element logical vector indicating if x1/x2/x3 should be used (TRUE) or ignored (FALSE)
#' @param im index of current metabolite
#' @param metab metab list generated by read_metabdb()
#' @param prm prm list generated by initialize_prm()
#' @param rtshift known shift in retention time relative to reference chromatogram
#' @param rangestart offset between peakstart/peaktop/peakend and start of x1/x2/x3
#' @param refqs_list output of get_quality_scores for peak in reference sample
#'
#' @return qs list of quality scores for peak ("now") and alternative peak ("alt")
#'
#' @export
get_extended_quality_scores <- function(x1, x2, x3, peakstart, peaktop, peakend, nowusetrace, im, metab, prm, rtshift = 0, refqs_list) {
  
  # if peakstart is outside measured range, put to first value of measured range
  # but only if there actually is measured data
  if (sum(x1 > 0, na.rm = TRUE) > 5) {
    datarange = which( x1 > 0 )
    if (peakstart < min(datarange) )  peakstart <- datarange[1]
    if (peakend > max(datarange) )  peakend <- max(datarange)
  }
  
  nowqs <- get_quality_scores(x1, x2, x3, peakstart, peaktop, peakend, nowusetrace, im, metab, prm, rtshift = rtshift)
  
  # additionally get second highest peak and determine qs$H for it and
  # * add this value as QS to the peak
  # * add best and second highest peak to qslog_report as neg example
  #   for training of model_pick_batch
  
  x1slope <- diff(x1+x3) # slope
  x1switch <- diff(sign(x1slope))
  local_max <- which(x1switch == -2) #local maxima
  local_min <- which(x1switch == 2) #local minima
  altpeaktops <- local_max[order(x1[local_max], decreasing=T)]
  altpeaktop <- altpeaktops[c(which(altpeaktops < peakstart), which(altpeaktops > peakend))]
  if (length(altpeaktop) == 0) {
    # whole range seems to be selected as peak, so take something towards the end of the range as alternative peak
    altpeaktop <- max(altpeaktops[altpeaktops < (peakend - 10)])
  }
  altpeaktop <- altpeaktop[1]
  altpeakstart <- max(c(local_min[sign(local_min - altpeaktop) < 0],1))
  altpeakend <- min(c(local_min[sign(local_min - altpeaktop) > 0],length(x1)))
  altnowqs <- get_quality_scores(x1, x2, x3, altpeakstart, altpeaktop, altpeakend, nowusetrace, im, metab, prm, rtshift = rtshift)
  
  
  # Set final quality score
  if (prm$ml_type == 'mltrain_pick'){
    final_peak_class <- list('H' = mean(as.numeric(nowqs)) )
    nowqs$QS_altqs <- mean(as.numeric(altnowqs))
  } else {
    alttrans <- predict(prm$train_preprocessing, as.data.frame(altnowqs) )
    altclass <- predict(prm$model, alttrans,type="prob")
    nowqs$QS_altqs <- altclass$H
    
    trans <- predict(prm$train_preprocessing, as.data.frame(nowqs) )
    final_peak_class <- predict(prm$model, trans,type="prob")
  }
  
  # dRT minus median dRT in refsample converted to score like dRT
  nowqs$QS_dRTref <- ( 1/(1+abs(
    (1/sqrt(nowqs$QS_dRT)) - (1/sqrt(refqs_list$QS_dRT)) 
  )) )^2
  
  # extend altnowqs
  altnowqs$QS_altqs <- final_peak_class$H
  altnowqs$QS_dRTref <- ( 1/(1+abs(
    (1/sqrt(altnowqs$QS_dRT)) - (1/sqrt(refqs_list$QS_dRT)) 
  )) )^2
  
  qs <- list('now' = nowqs, 'alt' = altnowqs)
  
  qs
  
  
}